<?php

/*
Plugin Name: Nofollow Tags For Movies Sites
Plugin URI: http://www.movski.com
Description: Nofollow Tags For Movies Sites adds the nofollow tag to all of your outgoing links to video hosting websites. Perfect if you're running a video / Movies / Tv / Anime blog. 
Author: Jeff Standerson
Version: 1.1
Author URI: http://www.movski.com
*/

/*	Copyright 2009	Mark Parsons 
   

*/

function wp_get_domain_name_from_uri($uri){
	preg_match("/^(http:\/\/)?([^\/]+)/i", $uri, $matches);
	$host = $matches[2];
	preg_match("/[^\.\/]+\.[^\.\/]+$/", $host, $matches);
	return $matches[0];	   
}

function wp_has_no_rel_nofollow($text)
{
	if ( preg_match("/rel=[\"\'].*?nofollow.*?[\"\']/i", $text ) )
		return false;
	else
		return true;
}

function wp_inarray($needle, $array, $searchKey = false)
{
   if ($searchKey) {
       foreach ($array as $key => $value)
           if (stristr($key, $needle)) {return $key;}
       }
   else {
       foreach ($array as $value)
           if (stristr($value, $needle)) {return $value;}
       }
   return '';
}

function parse_nofollow_movies($matches)
{
	//If you would like to add more video hosting sites to add the nofollow tag to, please enter their url in the list below. Although being such masters in the field we don't think we've missed ANY out!

	if ( 	wp_inarray(wp_get_domain_name_from_uri($matches[3]), array("4shared.com",
"56.com",
"beta.miloyski.com",
"bigupload.com",
"blinkx.com",
"blip.tv",
"bolt.com",
"boltfolio.com",
"clipshack.com",
"cruncyroll.com",
"dailymotion.com",
"divxden.com",
"divxstage.net",
"divxvine.com",
"filebase.to",
"freestreamtube.com",
"gougou.com",
"graboid.com",
"infinitemb.com",
"ku6.cn",
"megashare.com",
"megashares.com",
"megaupload.com",
"megavideo.com",
"metacafe.com",
"motionbox.com",
"movshare.net",
"myspace.com",
"mystream.to",
"novamov.com",
"ouou.com",
"rapidshare.com",
"revver.com",
"stagevu.com",
"supernovatube.com",
"stream2k.com",
"streamleech.com",
"themoviedownloads.com",
"todou.com",
"truveo.com",
"veoh.com",
"upzilla.net",
"vhead.blog.sina.com.cn",
"video44.com",
"videoegg.com",
"vimeo.com",
"wartog.info",
"wisevid.com",
"xtshare.com",
"youko.com",
"youtube.com",
"zangocash.com",
"zhare.net")) &&
		  wp_has_no_rel_nofollow( $matches[1] ) &&
		  wp_has_no_rel_nofollow( $matches[4] ) )
	{
		return '<a rel="nofollow" href="' . $matches[2] . '//' . $matches[3] . '" ' . $matches[1] . $matches[4] . '>' . $matches[5] . '</a>';
	}
	else
	{
		// Do nothing
		return '<a href="' . $matches[2] . '//' . $matches[3] . '" ' . $matches[1] . $matches[4] . '>' . $matches[5] . '</a>';
	}
}
	

function wp_nofollow_movies($text) 
{
	$pattern = '/<a (.*?)href=[\"\'](.*?)\/\/(.*?)[\"\'](.*?)>(.*?)<\/a>/i';
	$text = preg_replace_callback($pattern,'parse_nofollow_movies',$text);
	return $text;
}

// filters have high priority to make sure that any markup plugins like Textile or Markdown have already created the HTML links
add_filter('the_content', 'wp_nofollow_movies', 999);
add_filter('the_excerpt', 'wp_nofollow_movies', 999);

// delete this one if you don't want it run on comments
add_filter('comment_text', 'wp_nofollow_movies', 999);
//add_filter('get_comment_author_link', 'wp_nofollow_movies', 999);

function wp_nofollow_movies_insert_link() {
	echo ('<p></p>');
}

add_action('wp_footer', 'wp_nofollow_movies_insert_link',999);

?>
